//+------------------------------------------------------------------+
//|                                            SingleNextBarDemo.mqh |
//|      common stuff for SingleBar.mq5 & NextBar.mq5 & OLAPQRWF.mq5 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                            https://www.mql5.com/ru/articles/7535 |
//+------------------------------------------------------------------+
#ifndef __MT4ORDERS__
#include <MT4Bridge/MT4Orders.mqh>
#endif

int parseHours(const string &data, int &result[])
{
  string str[];
  const int n = StringSplit(data, ',', str);
  ArrayResize(result, n);
  for(int i = 0; i < n; i++)
  {
    result[i] = (int)StringToInteger(str[i]);
  }
  return n;
}

template<typename T>
int ArrayFind(const T &array[], const T value)
{
  const int n = ArraySize(array);
  for(int i = 0; i < n; i++)
  {
    if(array[i] == value) return i;
  }
  return -1;
}

int CurrentOrderDirection(const string symbol = NULL)
{
  for(int i = OrdersTotal() - 1; i >= 0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS))
    {
      if(OrderType() <= OP_SELL && (symbol == NULL || symbol == OrderSymbol()))
      {
        return OrderType() == OP_BUY ? +1 : -1;
      }
    }
  }
  return 0;
}

void OrdersCloseAll(const string symbol = NULL, const int type = -1) // OP_BUY or OP_SELL
{
  for(int i = OrdersTotal() - 1; i >= 0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS))
    {
      if(OrderType() <= OP_SELL && (type == -1 || OrderType() == type) && (symbol == NULL || symbol == OrderSymbol()))
      {
        OrderClose(OrderTicket(), OrderLots(), OrderType() == OP_BUY ? SymbolInfoDouble(OrderSymbol(), SYMBOL_BID) : SymbolInfoDouble(OrderSymbol(), SYMBOL_ASK), 100);
      }
    }
  }
}
